<?php

namespace FiloBlu\Flow\Console\Command;

use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;


class ReceiveCommand extends Command
{

    protected $state;

    public function __construct(
        \Magento\Framework\App\State $state
    )
    {
        $this->state = $state;
        return parent::__construct();
    }

    protected function configure()
    {
        $this->setName('flow:receive')->setDescription('Receive files/data from remote source');
    }

    protected function execute(InputInterface $input, OutputInterface $output)
    {
        if (!$this->state->getAreaCode()) {
            $this->state->setAreaCode('adminhtml');
        }
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $this->cronModel = $objectManager->create('\FiloBlu\Flow\Cron\Fetch');
        $this->cronModel->receive();
        $output->writeln('<info>Receive executed !</info>');
    }

}