<?php
namespace FiloBlu\Flow\Model\From;


abstract class AbstractFrom extends \Magento\Framework\Model\AbstractModel {

    const PRODUCT_NOT_FOUND_META_STATUS = -2;
    protected $_error_message;

    abstract public function process();

    public function setProcessed() {
        $now = date();
        $this->setMetaProcessed(true)
            ->setMetaProcessTime($now);
        return $this;
    }

    protected function error($blocking, $msg) {

        if ($blocking) {
            throw new \Exception($msg);
        } else {
            $this->setErrorMessage($this->_error_message."\r\n".$msg);
            return false;
        }
    }

    public function setErrorMessage($msg) {
        $this->_error_message = $msg;
    }

    public function getErrorMessage() {
        return $this->_error_message;
    }

    public function processFileRows($file) {

        $connection = $this->getResource()->getConnection();

        $rows = $this->getCollection()
            ->addFieldToFilter('meta_file',$file->getId())
            ->addFieldToFilter('meta_processed',0)
            ->setOrder("meta_ref_id","ASC");

        $query = $connection->query((String)$rows->getSelect());
        //$connection->beginTransaction();
        foreach($query->fetchAll() as $row){
            try{
                $this->setData($row);
                $this->process();
                $connection->query("Update " . $this->getResource()->getMainTable() . " set meta_processed = 1 where meta_id = ".$row["meta_id"]);
            }catch(\Exception $e){
                //$connection->rollback();
                $message = 'processing item '.$row["meta_id"].': '.$e->getMessage();
                throw new \Exception($message);
            }
        }
        return $file;
        //$connection->commit();

    }

    public function clean($file) {

        if (!$file->getId())
            return false;

        $connection = $this->getResource()->getConnection();

        try {

            $sql = "delete from " . $this->getResource()->getMainTable() ." where meta_file = " . $file->getId();
            $connection->query($sql);

        } catch (\Exception $e) {

            $message = 'processing item '.$file->getName().': '.$e->getMessage();
            throw new \Exception($message);

        }

    }

}